



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>springcloud ribbon 客户端负载均衡用法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">springcloud ribbon 客户端负载均衡用法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 21:08:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>org.springframework.web.util.NestedServletException: Request processing failed; nested exception is org.springframework.web.client.ResourceAccessException: I/O error on GET request for "http://DEPT-8001/dept/get/1": DEPT-8001; nested exception is java.net.UnknownHostException: DEPT-8001</p>
<p>不识别主机名称、则可能是主机名称没在系统文件hosts中配置，但检查发现，已经配置，排除。</p>
<p>于是查了一下Ribbon的用法，发现使用Ribbon的时候，必须要在RestTemplate bean配置中添加负载均衡注解@LoadBalanced</p>
<p>于是加完如下：</p>
<p>package com.zemel.consumer.config;</p>
<p>import java.nio.charset.Charset;<br />import java.util.Base64;</p>
<p>import org.springframework.cloud.client.loadbalancer.LoadBalanced;<br />import org.springframework.context.annotation.Bean;<br />import org.springframework.context.annotation.Configuration;<br />import org.springframework.http.HttpHeaders;<br />import org.springframework.web.client.RestTemplate;</p>
<p>@Configuration<br />public class RestConfig {</p>
<p>@Bean<br />	public HttpHeaders getHeaders(){<br />		// 进行一个Http头信息配置<br />		HttpHeaders headers = new HttpHeaders();<br />		String auth = "wendy:wendy";<br />		byte[] encodedAuth = Base64.getEncoder().encode(auth.getBytes(Charset.forName("US-ASCII")));<br />		// 加密字符串要有空格<br />		String authHeader = "Basic " + new String(encodedAuth);</p>
<p>headers.set("Authorization", authHeader);<br />		return headers;<br />	}</p>
<p>@Bean<br />	@LoadBalanced<br />	public RestTemplate getRestTemplate(){<br />		return new RestTemplate();<br />	}</p>
<p>}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8odx1qz.html">Struts2入门&lpar;五&rpar;&mdash;&mdash;OGNL和标签库</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq10ln68.html">&lbrack;CareerCup&rsqb; 1&period;8 String Rotation 字符串的旋转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oknwo59.html">&lbrack;xcode&rsqb;instruments来检验你的app</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1p7xq.html">Codeforces Round &num;374 &lpar;Div&period; 2&rpar; A B C D 水 模拟  dp&plus;dfs  优先队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmlnrx9.html">同名域中计算机之间RDP问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1g5ek8.html">HTTPClient模块的HttpGet和HttpPost</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k160759.html">install Active Directory域控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdevpzv9.html">【HDOJ】1556 Color the ball</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnpoez8.html">slime&plus;sbcl for common lisp</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yy5mw8.html">于ios7在遇到一些发展deprecated问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mjvvn8.html">基于心跳的socket长连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey5xrx9.html">django的HTTPREQUEST对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdp559.html">weblogic漏洞修复：CVE-2014-4210，UDDI Explorer对外开放</a>
		</li>
						<li><a href="https://www.batexi.com/a/9genz108.html">JAVA RPC &lpar;六&rpar; 之thrift反序列化RPC消息体</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xore9.html">【SQLite】简单的基本使用步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o1eje8.html">kubernetes 创建nginx 容器</a>
		</li>
						<li><a href="https://www.batexi.com/a/963pvz39.html">【Python】使用torrentParser1&period;03对单文件torrent的分析结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qverr6y9.html">面向过程中的局部变量（global）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpgdr09.html">zookeeper集群崩溃处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kvn0wq.html">SPOJ  3267&period; D-query （主席树，查询区间有多少个不相同的数）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mzjmo8.html">&lbrack;Python Web&rsqb;部署完网站需要做的基本后续工作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me3l2pq.html">《HelloGitHub月刊》第 09 期</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mzjkj8.html">【Python3爬虫】Scrapy入门教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pxywn8.html">Docker系列04&mdash;Docker的网络模式详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jo35v8.html">Spring Boot （七）MyBatis代码自动生成和辅助插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9504zkv8.html">WebClient下载文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mz46n8.html">第一册：lesson 103&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge2znz8.html">win10连接无线网，开启移动热点，手机连接它手机一直显示获取ip地址中。</a>
			</li>
						<li><a href="https://www.batexi.com/a/9504z5e8.html">C&num;单例模式的几种实现方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwgo48.html">java-初识Properties</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
